package com.cocos2dx.BBCNAndroid;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.util.Log;

import com.mobage.android.Error;
import com.mobage.android.social.PagingOption;
import com.mobage.android.social.PagingResult;
import com.mobage.android.social.User;
import com.mobage.android.social.common.Appdata;
import com.mobage.android.social.common.Profanity;
import com.mobage.android.social.common.Appdata.OnDeleteEntriesComplete;
import com.mobage.android.social.common.Appdata.OnGetEntriesComplete;
import com.mobage.android.social.common.Appdata.OnUpdateEntriesComplete;
import com.mobage.android.social.common.Blacklist;
import com.mobage.android.social.common.Blacklist.OnCheckBlacklistComplete;
import com.mobage.android.social.common.People;
import com.mobage.android.social.common.People.OnGetUserComplete;
import com.mobage.android.social.common.People.OnGetUsersComplete;
import com.mobage.android.social.common.Profanity.OnCheckProfanityComplete;
import com.mobage.android.social.common.RemoteNotification;
import com.mobage.android.social.common.RemoteNotification.OnGetRemoteNotificationsEnabledComplete;
import com.mobage.android.social.common.RemoteNotification.OnSetRemoteNotificationsEnabledComplete;

public class MobageAdapter {
    
	private static final String m_tag = "MobageAdapterJava";
    
	public static class OnCompleteBase {
		public String method;
		public int request_id;
        
		public OnCompleteBase(String jsonStr) {
            
			JSONObject json;
            
			try {
				json = new JSONObject(jsonStr);
                
				request_id = json.getInt("request_id");
				method = json.getString("method");
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
        
		public void setResponseJson(JSONObject json, boolean methodResult) {
            
			try {
                
				json.put("request_id", request_id);
				json.put("result", methodResult);
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
    
	public static class OnGetEntriesWrapper extends OnCompleteBase implements OnGetEntriesComplete {
        
		public static final String OutEntriesConstant = "GetEntries";
		public static final String InKeysConstant = "Keys";
        
		public OnGetEntriesWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}
        
		@Override
		public void onSuccess(HashMap<String, String> paramHashMap) {
			// TODO Auto-generated method stub
            
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
            
			try {
				JSONObject GetEntriesObject = new JSONObject(paramHashMap);
				json.put(OutEntriesConstant, GetEntriesObject);
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
        
		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
            
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
    
	public static class OnUpdateEntriesWrapper extends OnCompleteBase implements OnUpdateEntriesComplete {
        
		public static final String OutEntriesConstant = "UpdateEntries";
		public static final String InEntriesConstant = "Entries";
        
		public OnUpdateEntriesWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}
        
		@Override
		public void onSuccess(ArrayList<String> paramArrayList) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
            
			try {
				JSONArray UpdateEntriesObject = new JSONArray(paramArrayList);
                
				json.put(OutEntriesConstant, UpdateEntriesObject);
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
        
		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
        
	}
    
	public static class OnDeleteEntriesWrapper extends OnCompleteBase implements OnDeleteEntriesComplete {
        
		public static final String OutEntriesConstant = "DeleteEntries";
		public static final String InKeysConstant = "Keys";
        
		public OnDeleteEntriesWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}
        
		@Override
		public void onSuccess(ArrayList<String> paramArrayList) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
            
			try {
				JSONArray DeleteEntriesObject = new JSONArray(paramArrayList);
                
				json.put(OutEntriesConstant, DeleteEntriesObject);
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
        
		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
        
	}
    
	public static class OnCheckBlacklistWrapper extends OnCompleteBase 	implements OnCheckBlacklistComplete {
        
		public static final String OutUserIdsConstant = "UserIds";
		public static final String InUserIdConstant = "UserId";
		public static final String InTargetUserIdConstant = "TargetUserId";
		public static final String InMBGOptionConstant = "MBGOption";
        
		public OnCheckBlacklistWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}
        
		@Override
		public void onSuccess(ArrayList<String> paramArrayList,
                              PagingResult paramPagingResult) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
            
			try {
				JSONArray CheckBlacklistObject = new JSONArray(paramArrayList);
                
				json.put(OutUserIdsConstant, CheckBlacklistObject);
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
        
		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
        
	}
    
	public static class OnGetUserWrapper extends OnCompleteBase implements OnGetUserComplete {
        
		public static final String InUserIdConstant = "UserId";
		
		public OnGetUserWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}
        
		@Override
		public void onSuccess(User paramUser) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
            
			try {
                
				json.put("mbg_user_id" , paramUser.getId() );
				json.put("mbg_nick_name" , paramUser.getNickname() );
				
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
        
		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
	}
	
	public static class OnGetUsersWrapper extends OnCompleteBase implements OnGetUsersComplete {

		public static final String InUserIdsConstant = "UserIds";
//		public static final String OutCountConstant = "Count";
		public static final String OutUsersConstant = "Users";
		
		public OnGetUsersWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}

		@Override
		public void onSuccess(ArrayList<User> paramArrayList,
				PagingResult paramPagingResult) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
            
			try {
            
				JSONArray users = new JSONArray();
				
				int length = paramArrayList.size();
				for(int i = 0 ; i < length ; ++i) {
					JSONObject user = new JSONObject();
					user.put("mbg_user_id" , paramArrayList.get(i).getId() );
					user.put("mbg_nick_name" , paramArrayList.get(i).getNickname() );
					
					users.put( user );
				}
				
				json.put( OnGetUsersWrapper.OutUsersConstant , users );
//				json.put( OnGetUsersWrapper.OutCountConstant , paramPagingResult.total );
				
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString()); 
				
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
	}
	
	public static class OnGetFriendsWrapper extends OnCompleteBase implements OnGetUsersComplete {

		public static final String InUserIdConstant = "UserId";
		public static final String InMBGOptionConstant = "MBGOption";
		public static final String OutUsersConstant = "Users";
		
		public OnGetFriendsWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}

		@Override
		public void onSuccess(ArrayList<User> paramArrayList,
				PagingResult paramPagingResult) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
            
			try {
            
				JSONArray users = new JSONArray();
				
				int length = paramArrayList.size();
				for(int i = 0 ; i < length ; ++i) {
					JSONObject user = new JSONObject();
					user.put("mbg_user_id" , paramArrayList.get(i).getId() );
					user.put("mbg_nick_name" , paramArrayList.get(i).getNickname() );
					
					users.put( user );
				}
				
				json.put( OnGetFriendsWrapper.OutUsersConstant , users );
				
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString()); 
				
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
	}
	
	public static class OnGetFriendsWithGameWrapper extends OnCompleteBase implements OnGetUsersComplete {

		public static final String InUserIdConstant = "UserId";
		public static final String InMBGOptionConstant = "MBGOption";
		public static final String OutUsersConstant = "Users";
		
		public OnGetFriendsWithGameWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}

		@Override
		public void onSuccess(ArrayList<User> paramArrayList,
				PagingResult paramPagingResult) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
            
			try {
            
				JSONArray users = new JSONArray();
				
				int length = paramArrayList.size();
				for(int i = 0 ; i < length ; ++i) {
					JSONObject user = new JSONObject();
					user.put("mbg_user_id" , paramArrayList.get(i).getId() );
					user.put("mbg_nick_name" , paramArrayList.get(i).getNickname() );
					
					users.put( user );
				}
				
				json.put( OnGetFriendsWithGameWrapper.OutUsersConstant , users );
				
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString()); 
				
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	public static class OnCheckProfanityWrapper extends OnCompleteBase implements OnCheckProfanityComplete {

		public static final String InCheckTextConstant = "CheckText";
		public static final String OutCheckResultConstant = "CheckResult";
		
		public OnCheckProfanityWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}

		@Override
		public void onSuccess(boolean paramBoolean) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
            
			try {
				
				json.put( OutCheckResultConstant , paramBoolean );
				
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString()); 
				
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
	}
	
	public static class OnGetRemoteNotificationsEnabledWrapper extends OnCompleteBase implements OnGetRemoteNotificationsEnabledComplete {

		public static final String OutGetRemoteNotificationsEnabledConstant = "GetRemoteNotificationsEnabled";
		
		public OnGetRemoteNotificationsEnabledWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}

		@Override
		public void onSuccess(boolean paramBoolean) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
            
			try {
				
				json.put( OutGetRemoteNotificationsEnabledConstant , paramBoolean );
				
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString()); 
				
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
	}
	
	public static class OnSetRemoteNotificationsEnabledWrapper extends OnCompleteBase implements OnSetRemoteNotificationsEnabledComplete {

		public static final String InIsEnabledConstant = "IsEnabled";
		
		public OnSetRemoteNotificationsEnabledWrapper(String jsonStr) {
			super(jsonStr);
			// TODO Auto-generated constructor stub
		}

		@Override
		public void onSuccess() {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, true);
			
			Log.v(m_tag, "Prepare callNative : " + json.toString());
			callNative(json.toString());
		}

		@Override
		public void onError(Error paramError) {
			// TODO Auto-generated method stub
			JSONObject json = new JSONObject();
			setResponseJson(json, false);
            
			try {
				json.put("error_code", paramError.getCode());
				json.put("error_description", paramError.getDescription());
                
				Log.v(m_tag, "Prepare callNative : " + json.toString());
				callNative(json.toString());
                
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
	}
	
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *            jsonStr : InKeysConstant is an array
	 */
	public static void getEntries(String jsonStr) {
        
		try {
            
			JSONObject json = new JSONObject(jsonStr);
			JSONArray jsonArr = json
            .getJSONArray(OnGetEntriesWrapper.InKeysConstant);
            
			ArrayList<String> keys = new ArrayList<String>();
            
			int length = jsonArr.length();
			for (int i = 0; i < length; ++i)
				keys.add(jsonArr.getString(i));
            
			Appdata.getEntries(keys, new OnGetEntriesWrapper(jsonStr));
            
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
    
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *            jsonStr : InEntriesConstant is an array of pair<String,String>
	 */
	public static void updateEntries(String jsonStr) {
        
		try {
            
			JSONObject json = new JSONObject(jsonStr);
			JSONObject jsonMap = json
            .getJSONObject(OnUpdateEntriesWrapper.InEntriesConstant);
			HashMap<String, String> entries = new HashMap<String, String>();
            
			Iterator iterator = jsonMap.keys();
			while (iterator.hasNext()) {
				String key = iterator.next().toString();
				String mapped = jsonMap.getString(key);
                
				entries.put(key, mapped);
			}
            
			Appdata.updateEntries(entries, new OnUpdateEntriesWrapper(jsonStr));
            
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
    
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *            jsonStr : InKeysConstant is an array
	 */
	public static void deleteEntries(String jsonStr) {
        
		try {
            
			JSONObject json = new JSONObject(jsonStr);
			JSONArray jsonArr = json
            .getJSONArray(OnDeleteEntriesWrapper.InKeysConstant);
            
			ArrayList<String> keys = new ArrayList<String>();
            
			int length = jsonArr.length();
			for (int i = 0; i < length; ++i)
				keys.add(jsonArr.getString(i));
            
			Appdata.deleteEntries(keys, new OnDeleteEntriesWrapper(jsonStr));
            
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
    
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *            UserId is a string , TargetUserId is a string , MBGOption is a
	 *            two elements array
	 */
	public static void checkBlacklist(String jsonStr) {
        
		try {
            
			JSONObject json = new JSONObject(jsonStr);
            
			String userId = json
            .getString(OnCheckBlacklistWrapper.InUserIdConstant);
			String targetUserId = json
            .getString(OnCheckBlacklistWrapper.InTargetUserIdConstant);
			JSONArray option = json
            .getJSONArray(OnCheckBlacklistWrapper.InMBGOptionConstant);
            
			PagingOption options = new PagingOption();
			options.start = option.getInt(0);
			options.count = option.getInt(1);
            
			Blacklist.checkBlacklist(userId, targetUserId, options,
                                     new OnCheckBlacklistWrapper(jsonStr));
            
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
    
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *     UserId is a string 
	 */
	public static void getUser( String jsonStr ) {
		
		try {
			
			JSONObject json = new JSONObject( jsonStr );
			String userId = json.getString( OnGetUserWrapper.InUserIdConstant );
			
			User.Field[] fields = {
                User.Field.ID,
                User.Field.NICKNAME,
                User.Field.HAS_APP,
                User.Field.GRADE,
                User.Field.IS_FAMOUS
            };
			
			People.getUser( userId , fields , new OnGetUserWrapper(jsonStr) );
			
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *    NULL 
	 */
	public static void getCurrentUser( String jsonStr ) {
		try {
			
			JSONObject json = new JSONObject( jsonStr );
			
			User.Field[] fields = {
                User.Field.ID,
                User.Field.NICKNAME,
                User.Field.HAS_APP,
                User.Field.GRADE,
                User.Field.IS_FAMOUS
            };
			
			People.getCurrentUser( fields , new OnGetUserWrapper(jsonStr) );
			
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *   UserIds is an array
	 */
	public static void getUsers( String jsonStr ) {
		
		try {
			
			JSONObject json = new JSONObject( jsonStr );
			JSONArray jsonUserIds = json.getJSONArray( OnGetUsersWrapper.InUserIdsConstant );
			
			User.Field[] fields = {
                User.Field.ID,
                User.Field.NICKNAME,
                User.Field.HAS_APP,
                User.Field.GRADE,
                User.Field.IS_FAMOUS
            };
			
			ArrayList<String> userIds = new ArrayList<String>();
			int length = jsonUserIds.length();
			for(int i = 0 ; i < length ; ++i) {
				userIds.add( jsonUserIds.getString(i) );
			}
			
			People.getUsers( userIds , fields , new OnGetUsersWrapper(jsonStr) );
			
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *     userId is a string
	 */
	public static void getFriends( String jsonStr ) {
		
		try {
			
			JSONObject json = new JSONObject( jsonStr );
			String userId = json.getString( OnGetFriendsWrapper.InUserIdConstant );
			JSONArray option = json.getJSONArray(OnGetFriendsWrapper.InMBGOptionConstant);
			
			User.Field[] fields = {
                User.Field.ID,
                User.Field.NICKNAME,
                User.Field.HAS_APP,
                User.Field.GRADE,
                User.Field.IS_FAMOUS
            };
			
			PagingOption options = new PagingOption();
			options.start = option.getInt(0);
			options.count = option.getInt(1);
			
			People.getFriends( userId , fields , options , new OnGetFriendsWrapper(jsonStr) );
			
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *   userId is a string
	 *   MBGOption is an array of 2 elements
	 */
	public static void getFriendsWithGame( String jsonStr ) {
		
		try {
            
			JSONObject json = new JSONObject(jsonStr);
            
			String userId = json.getString(OnGetFriendsWithGameWrapper.InUserIdConstant);
			JSONArray option = json.getJSONArray(OnGetFriendsWithGameWrapper.InMBGOptionConstant);
            
			PagingOption options = new PagingOption();
			options.start = option.getInt(0);
			options.count = option.getInt(1);
            
			User.Field[] fields = {
	                User.Field.ID,
	                User.Field.NICKNAME,
	                User.Field.HAS_APP,
	                User.Field.GRADE,
	                User.Field.IS_FAMOUS
	            };
			
			People.getFriendsWithGame( userId , fields , options , new OnGetFriendsWithGameWrapper(jsonStr) );
            
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *    CheckText is a string
	 */
	public static void checkProfanity( String jsonStr ) {
		
		try {
            
			JSONObject json = new JSONObject(jsonStr);
            
			String text = json.getString( OnCheckProfanityWrapper.InCheckTextConstant );
			
			Profanity.checkProfanity( text , new OnCheckProfanityWrapper(jsonStr) );
            
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *    None
	 */
	public static void getRemoteNotificationsEnabled( String jsonStr ) {
		
		RemoteNotification.getRemoteNotificationsEnabled( new OnGetRemoteNotificationsEnabledWrapper(jsonStr) );
		
	}
	
	/**
	 * @author dongshihao
	 * @param jsonStr
	 *    IsEnabled is a boolean
	 */
	public static void setRemoteNotificationsEnabled( String jsonStr ) {
		
		try {
            
			JSONObject json = new JSONObject(jsonStr);
			boolean isEnabled = json.getBoolean( OnSetRemoteNotificationsEnabledWrapper.InIsEnabledConstant );
			
			RemoteNotification.setRemoteNotificationsEnabled( isEnabled , new OnSetRemoteNotificationsEnabledWrapper(jsonStr) );
            
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	static {
		System.loadLibrary(Constant.libname);
	}
    
	public native static void callNative(String jsonStr);
}
